cut;
mlbasics_;
SYMTAB_;
STCHATTR_;
SEQPAIRS_;
SEQDUP_;
step7sargs_;
nilandlength_;
memandism_;
uniqueids_;
[lkuplems_=Prop];


(**************************************************************)
Goal {i:ident}{s:Ssequence}
(isnotthecase (Sismatch i s))->Q null_attrib (lookup_tw s i);
(**************************************************************)
Intros i s;
Refine rec_ind??????([s:Ssequence][f:Ssequence->ident->attrib]
(isnotthecase (Sismatch i s))->Q null_attrib (f s i));
Refine lkup_bc;Refine lkup_cc;Refine Slength;

(** monotonicity of maxeval=Slength **)
Intros __H;Refine H;

(** continuity of P **)
Intros s2 f1 f2 hyp hyp1;
Refine unext ??(hyp??)?[a:attrib]
(isnotthecase (Sismatch i s2))->Q null_attrib a;
Refine LE_refl;Refine hyp1;

(** base case **)
Intros ___;Refine Q_refl;

(** inductive case **)
Intros lkup s2 indhyp;(** s = Snil **)
Refine expandseq[s2:Ssequence](isnotthecase (Sismatch i s2))->Q null_attrib (if (Snull s2) (lkup_base s2) (lkup_scheme s2 lkup) i);

(** s = Snil **)
Intros __;
Refine unext ??(iftrue ?????)?[a:attrib]Q null_attrib a;
Refine Snull1;Refine Q_refl;

(** s= Scons e s' **)
Intros s' e1 e2 qsconss;
Refine bycases (eqid i e1);
Intros iqe1; (** 1st case by contradiction **)
Intros nomatch;
Refine contradiction (Sismatch i (Scons (pair e1 e2) s'));
Refine Q_sym (Sismatch2????) [x:bool]isthecase x;
Refine iqe1[x:bool]isthecase (orelse x(Sismatch i s'));
Refine Q_refl;
Refine nomatch;
Intros inqe1; (** 2nd case by indhyp **)
Refine Q_sym (Sismatch2????)[x:bool](isnotthecase x)
->Q null_attrib (if (Snull ?) (lkup_base ?) (lkup_scheme ? lkup) i);
Refine inqe1[x:bool](isnotthecase (orelse x(Sismatch i s')))->Q null_attrib ?;
Qrepl (Q_sym (Snull2 (pair e1 e2) s'));
Refine iffalse?????[a:attrib](isnotthecase (Sismatch i s'))->Q null_attrib a;
Refine Q_sym (Shdax ??)[e:PROD ident attrib]isnotthecase (eqid i (pi1 e));
Refine inqe1;
Refine Q_sym (Stlax ??)[s:Ssequence](isnotthecase (Sismatch i s'))->Q null_attrib (lkup s i);
Refine indhyp;
(** It remains to prove that s' indeed is shorter than s2 **)
Refine qsconss[x:Ssequence]LT (Slength s') (Slength x);
Refine Sconsrec ????[x:nat]LT (Slength s') x;
Refine LE_refl;
Save notismtonullattrib;


(******************************************************************)
Goal {i,i':ident}{s:Ssequence}
(isnotthecase (Sismatch i s))->(isnotthecase (Sismatch i (Sremove i' s)));
(******************************************************************)

Intros i i';Refine bycases (eqid i i');
Intros iqi' s _; (** i=i' by Sremove1 **)
IQI'==fst (Ident.2.2 i i') iqi';
Refine IQI'[i':ident]isnotthecase (Sismatch i (Sremove i' s));
Refine Sremove1;
Intros inqi'; (** 2nd case using member **)
Refine Sremove2;Intros member;
Refine uselocal;Intros eqe;
Refine uselocal;Intros eqt;
Refine uselocal;Intros memnil;
Refine uselocal;Intros memcons;
Intros memrem;
Intros s nomatch;
Refine notmemtonotism;
Immed;
Intros a;
Refine Q_sym (memrem ?????)[x:bool]isnotthecase x;
Refine eq_sym'????[x:bool]isnotthecase x;
Refine Ident.2.2;
Immed;
Refine notismtonotmem;
Immed;
Save notismtonotismrem;


(******************************************************************)
Goal
{member:(PROD ident attrib)->Ssequence->bool}
{eqe:(PROD ident attrib)->(PROD ident attrib)->bool}
{eqt:eqtype (PROD ident attrib) eqe}
{memnil:{e:PROD ident attrib}isnotthecase (member e Snil)}
{memcons:{e,e':PROD ident attrib}{s:Ssequence}
        Q (member e (Scons e' s)) (orelse (eqe e e')(member e s))}
{i:ident}{s:Ssequence}(isthecase (Sismatch i s))->
isthecase (member (pair i (lookup_tw s i)) s);
(******************************************************************)

Intros member eqe eqt memnil memcons i s;
Equiv (isthecase (Sismatch i s))->
isthecase (member (pair i (lookup_tw s i)) s);
Refine rec_ind??????([s:Ssequence][f:Ssequence->ident->attrib]
(isthecase (Sismatch i s))->isthecase (member (pair i (f s i)) s));
Refine lkup_bc;Refine lkup_cc;Refine Slength;
Intros __H;Refine H; (**monotonicity**)
Intros a f1 f2 H;
Refine unext ??(H??)?[x:attrib]
((isthecase (Sismatch i a))->isthecase (member (pair i (f1 a i)) a))->(isthecase (Sismatch i a))->isthecase (member (pair i x) a);
Refine LE_refl;Intros H1;Refine H1; (** continuity **)

(** base case **)
Intros s1 qszero ism;Refine contradiction (Sismatch i s1);
Refine ism;
Refine SlengthtoQSnil ? (Q_sym qszero)[x:Ssequence]
isnotthecase (Sismatch i x);
Refine Sismatch1;

(** inductive case **)
Intros lkup s1 indhyp;
Refine expandseq[s1:Ssequence](isthecase (Sismatch i s1))->isthecase (member (pair i (if (Snull s1) (lkup_base s1) (lkup_scheme s1 lkup) i)) s1);

Intros _ ism; (** case s1=Snil **)
Refine contradiction (Sismatch i Snil);
Refine ism;Refine Sismatch1;

Intros s' e1 e2 qscons ism; (** case s1 =(Scons e s') **)
Refine iffalse ?????[x:ident->attrib]
isthecase (member (pair i (x i)) (Scons (pair e1 e2) s'));
Refine Snull2;
Refine bycases (eqid i e1);
Intros iqe1;  (** 1st case by eval of the if part **)
Refine iftrue ?????[x:attrib]
isthecase (member (pair i x) (Scons (pair e1 e2) s'));
Refine Q_sym (Shdax ??)[x:PROD ident attrib]
isthecase (eqid i (pi1 x));
Refine iqe1;
Refine Q_sym (Shdax ??)[x:PROD ident attrib]
isthecase (member (pair i (pi2 x))(Scons (pair e1 e2) s'));
Refine Q_sym (memcons ???)[x:bool]isthecase x;
IQE1==fst(Ident.2.2 i e1)iqe1;
Refine Q_sym IQE1 [i:ident]isthecase (orelse (eqe (pair i (pi2 (pair e1 e2))) (pair e1 e2)) (member (pair i (pi2 (pair e1 e2))) s'));
Refine eq_refl ???[x:bool]isthecase (orelse x(member (pair e1 e2) s'));
Immed;
Refine Q_refl;
Intros inqe1; (** 2nd case by indhyp **) 
Refine iffalse ?????[x:attrib]isthecase (member (pair i x)(Scons (pair e1 e2) s'));
Refine Q_sym (Shdax ??)[e:PROD ident attrib]isnotthecase (eqid i (pi1 e));
Refine inqe1;
Refine Q_sym (Stlax ??)[x:Ssequence]isthecase (member (pair i (lkup x i))(Scons (pair e1 e2) s'));
Refine Q_sym (memcons ???)[x:bool]isthecase x;
Claim isnotthecase (eqe (pair i (lkup s' i)) (pair e1 e2));
Refine ?179[x:bool]isthecase (orelse x (member (pair i (lkup s' i)) s'));
Refine indhyp; (** this works but it remains to prove that ... **)
(**... A length reduction took place ...**)
Refine qscons[x:Ssequence]LT (Slength s') (Slength x);
Refine Sconsrec????[x:nat]LT (Slength s') x;
Refine LE_refl;
(** ... and that i is in s' ..*)
Equiv isthecase (orelse false (Sismatch i s'));
Refine Q_sym inqe1[x:bool]isthecase (orelse x (Sismatch i s'));
Refine Sismatch2????[x:bool]isthecase x;
Refine e2;
Refine ism; (** this follows from ism and inqe1 **)
(** Proof of the claim by contraposition(valid because of bool)**)
Refine snd (isnotthecase_correct ?);Intros H;
Refine fst (isnotthecase_correct?)inqe1;Refine snd (Ident.2.2??);
Refine Q_resp (pi1|?|?)(fst (eqt??) H);
Save lkuptomem;


(*****************************************************************)
Goal (* local *)
        Ex [member:(PROD ident attrib)->Ssequence->bool]
 	Ex [eqe:(PROD ident attrib)->(PROD ident attrib)->bool]
	Ex [eqt:eqtype (PROD ident attrib) eqe]
 
   	 (* axioms for member *)
	Ex [memnil:{e:PROD ident attrib}isnotthecase (member e Snil)]
	Ex [memcons:{e,e':PROD ident attrib}{s:Ssequence}
           Q (member e (Scons e' s)) (orelse (eqe e e')(member e s))]
(* in *) 
({i,i':ident}{a':attrib}{s:Ssequence}(isnotthecase (eqid i i'))->
     	  Q (member (pair i' a') (Sremove i s))
     	    (member (pair i' a') s))
/\
({s:symtab}{i:ident}{a,a':attrib}
     (isthecase (member (pair i a) s.1))->
     (isthecase (member (pair i a') s.1))->Q a a')
/\
({i:ident}{a:attrib}{s:symtab}  (** Here is the goal **)
     (isthecase (member (pair i a) s.1))->
     (Q a (lookup i s)));
(*****************************************************************)
Refine uniqueids;Intros member;
Refine uselocal;Intros eqe;
Refine uselocal;Intros eqt;
Refine uselocal;Intros memnil;
Refine uselocal;Intros memcons;
Intros memremanduniqueids;
memrem == fst memremanduniqueids;
uniq == snd memremanduniqueids;
Refine ExIntro;Refine member;
Refine ExIntro;Refine eqe;
Refine ExIntro;Refine eqt;
Refine ExIntro;Refine memnil;
Refine ExIntro;Refine memcons;
andI;Refine memrem;
andI;Refine uniq;

(*** The proof begins here ***)
Intros i a s;
Intros ismem;
Refine uniq;
Refine s;Refine i;
Refine ismem;
Refine lkuptomem;Immed;
Refine memtoism;Immed;
Refine ExIntro;
Refine a;
Refine ismem;
Save memtolkup;

