cut;
mlbasics_;
SYMTAB_;
STCHATTR_;
SEQPAIRS_;
SEQDUP_;

[seqdup_=Prop];

(*** Implementing SeqDup using the refinement mode ***)
Goal {Ident:IDENT}{Attrib:ATTRIB}{Seq:SEQPAIRS Ident Attrib}
       SEQDUP Ident Attrib Seq;
Intros ___;
[ident=Ident.1]
[eqid:ident->ident->bool=Ident.2.1]
[EQID:eqtype ident eqid=Ident.2.2];
[attrib=Attrib.1]
[eqattr:attrib->attrib->bool = Attrib.2.1]
[null_attrib:attrib=Attrib.2.2.1]
[EQATTR:eqtype attrib eqattr = Attrib.2.2.2]
[Ssequence=Seq.1]
[Snil:Ssequence=Seq.2.1]
[Scons:(PROD ident attrib)->Ssequence->Ssequence=Seq.2.2.1]
[Sseqrec:
       {R|Prop}R->((PROD ident attrib)->Ssequence->R->R)->
          Ssequence->R=Seq.2.2.2.1]
[Sseqind:
    {P:Ssequence->Prop}(P Snil)->
                   ({e:PROD ident attrib}{s:Ssequence}
                          (P s)->P (Scons e s))->
		   {s:Ssequence}P s=Seq.2.2.2.2.1]
[Snilrec:{R|Prop}{g:R}{h:(PROD ident attrib)->Ssequence->R->R}
	Q g (Sseqrec g h Snil)=Seq.2.2.2.2.2.1]
[Sconsrec:{R|Prop}{g:R}{h:(PROD ident attrib)->Ssequence->R->R}
      {e:PROD ident attrib}{s:Ssequence}	
      Q (h e s (Sseqrec g h s))(Sseqrec g h (Scons e s))
         =Seq.2.2.2.2.2.2.1]
[Snull:Ssequence->bool=Seq.2.2.2.2.2.2.2.1]
[Snull1:isthecase (Snull Snil)=Seq.2.2.2.2.2.2.2.2.1]
[Snull2:{e:PROD ident attrib}{s:Ssequence}
    isnotthecase (Snull (Scons e s))=Seq.2.2.2.2.2.2.2.2.2.1]
[Shd:Ssequence->PROD ident attrib=Seq.2.2.2.2.2.2.2.2.2.2.1]
[Shdax:{e:PROD ident attrib}{s:Ssequence}Q (Shd (Scons e s)) e
  =Seq.2.2.2.2.2.2.2.2.2.2.2.1]
[Stl:Ssequence->Ssequence=Seq.2.2.2.2.2.2.2.2.2.2.2.2.1]
[Stlax:{e:PROD ident attrib}{s:Ssequence}Q (Stl (Scons e s)) s
   =Seq.2.2.2.2.2.2.2.2.2.2.2.2.2]
;
[remove[i:ident] = Sseqrec Snil 
                        [e:PROD ident attrib][_:Ssequence][r:Ssequence]
                        if (eqid i (pi1 e)) r (Scons e r)];

[ismatch[i:ident]:Ssequence->bool=Sseqrec false
                             [e:PROD ident attrib][_:Ssequence][b:bool]
                                   orelse (eqid i (pi1 e)) b];

[add[e:PROD ident attrib][s:Ssequence] = if (ismatch (pi1 e) s)
                  (Scons e (remove (pi1 e) s))
                     (Scons e s)];

Intros #;Refine add;Intros #;Refine ismatch;Intros #;Refine remove;
Intros # i a s ism;Refine iftrue ????ism[x:Ssequence]
  Q x (Scons (p i a) (remove i s));Refine Q_refl;
Intros # i a s nism;Refine iffalse ????nism[x:Ssequence]
  Q x (Scons (p i a) s);Refine Q_refl;
Intros # i;Refine Snilrec;
Intros # i i' a' s;Refine Q_sym;Refine Sconsrec;Refine Q_refl;
Intros # i s;Refine Sseqind [s:Ssequence]isnotthecase (ismatch i (remove i s));
Refine Snilrec??[x:Ssequence]isnotthecase (ismatch i x);Refine Snilrec;
Intros e s hyp;Refine Sconsrec ???? [x:Ssequence]isnotthecase (ismatch i x);
Equiv isnotthecase (ismatch i 
       (if (eqid i (pi1 e))(remove i s1)(Scons e (remove i s1))));
Refine bycases (eqid i (pi1 e));Intros iqe1;
Refine iftrue????iqe1[x:Ssequence]isnotthecase (ismatch i x);Refine hyp;
Intros inqe1;Refine iffalse????inqe1[x:Ssequence]isnotthecase (ismatch i x);
Refine Sconsrec ???? isnotthecase;
Refine inqe1[x:bool]isnotthecase (orelse x (ismatch i (remove i s1)));
Refine hyp;
[eqe[e1,e2:PROD ident attrib]=andalso (eqid (pi1 e1)(pi1 e2))
    (eqattr (pi2 e1)(pi2 e2))];
[member[e:PROD ident attrib] = Sseqrec false
    [e':PROD ident attrib][_:Ssequence][b:bool]orelse (eqe e e') b];
Refine ExIntro;Refine member;Refine ExIntro;Refine eqe;Refine ExIntro;
Intros e e';andI; Intros eqe';Qrepl (prod_eta_elem e);Qrepl (prod_eta_elem e');
Refine fst (EQID (pi1 e)(pi1 e')) ? [x:ident]
          Q (p (pi1 e) (pi2 e)) (p x (pi2 e'));
Refine fst (fst (andalso_correct??)eqe');
Refine fst (EQATTR (pi2 e)(pi2 e'))?[x:attrib]
          Q (p (pi1 e) (pi2 e)) (p (pi1 e) x);
Refine snd (fst (andalso_correct??)eqe');Refine Q_refl;
Intros eQe';Refine eQe'[x:PROD ident attrib]isthecase (eqe e x);
Refine snd (andalso_correct??);andI;
Refine eq_refl;Refine EQID;Refine eq_refl;Refine EQATTR;

Refine ExIntro;Intros e;Refine Snilrec;
Refine ExIntro;Intros e e' s;Refine Q_sym;Refine Sconsrec;Refine Q_refl;

Intros i i' a' s inqi';
Refine Sseqind [s:Ssequence]
 Q (member (p i' a') (remove i s)) (member (p i' a') s);
Refine Snilrec??[x:Ssequence]
 Q (member (p i' a')x) (member (p i' a') Snil);Refine Q_refl;
Intros e s hyp;
Refine Sconsrec????[x:Ssequence]
 Q (member (p i' a') x) (member (p i' a') (Scons e s1));
Refine Sconsrec????[x:bool]
 Q (member (p i' a') (if (eqid i (pi1 e)) (remove i s1) 
          (Scons e (remove i s1)))) x;
Equiv Q (member (p i' a') (if (eqid i (pi1 e)) (remove i s1) 
        (Scons e (remove i s1)))) (orelse (eqe (p i' a') e)
          (member (p i' a') s1));
Refine bycases (eqid i (pi1 e));
Intros iqe1;Claim isnotthecase (eqe (p i' a') e);Qrepl(Q_sym?+1);
Refine iftrue????iqe1[x:Ssequence]
  Q (member (p i' a') x)(member (p i' a') s1);Refine hyp;
Refine snd (isnotthecase_correct?);Intros pqe;
Refine fst (isnotthecase_correct?)inqi';
Refine eq_trans;Refine EQID;Next +1;Refine iqe1;Refine eq_sym;Refine EQID;
Refine fst(fst(andalso_correct??)pqe);
Intros inqe1;Refine iffalse????inqe1[x:Ssequence]
  Q (member (p i' a') x)(orelse (eqe (p i' a') e)(member (p i' a') s1)); 
Refine Sconsrec????[x:bool]
  Q x (orelse (eqe (p i' a') e) (member (p i' a') s1));Refine bycases (eqe (p i' a') e);
Intros pqe;Qrepl(Q_sym pqe);Refine Q_refl;
Intros pnqe;Qrepl (Q_sym pnqe);Refine hyp;
Save SeqDup;


