cut;
SYMTAB_;
STCHATTR_;
[step2_=Prop];


 (* An inplementation of change_attrib in terms of add *)
(* We assume the arguments *)
[Ident:IDENT][Attrib:ATTRIB][St':SYMTAB' Ident Attrib]
[ident=Ident.1][eqid:ident->ident->bool=Ident.2.1]
[attrib=Attrib.1][null_attrib:attrib=Attrib.2.2.1]

(* and unpack the structure St' *)
[symtab=St'.1]
[empty:symtab=St'.2.1]
[add:ident->attrib->symtab->symtab=St'.2.2.1]
[present:ident->symtab->bool=St'.2.2.2.1]
[presempty:{i:ident}isnotthecase (present i empty)=St'.2.2.2.2.1]
[presadd:{a':attrib}{s:symtab}{i,i':ident}
                  Q (present i (add i' a' s)) 
                    (orelse (eqid i i')(present i s))=St'.2.2.2.2.2.1]
[lookup:ident->symtab->attrib=St'.2.2.2.2.2.2.1]
[lkupempty:{i:ident}Q (lookup i empty) null_attrib=St'.2.2.2.2.2.2.2.1]
[lkupadd1:{i:ident}{a:attrib}{s:symtab}
      		  Q (lookup i (add i a s)) a=St'.2.2.2.2.2.2.2.2.1]
[lkupadd2:{i,i':ident}{a':attrib}{s:symtab}
		  (isnotthecase (eqid i i')) ->
		  (Q (lookup i (add i' a' s)) (lookup i s))=
St'.2.2.2.2.2.2.2.2.2];




 
(* Implementing change_attrib in terms of add *)
	
[change_attrib[i:ident][a:attrib][s:symtab]=
   if (present i s) (add i a s) s];

(* Now we have to prove the axioms concerning change_attrib *)

Goal {i:ident}{a:attrib}{s:symtab}
            (isthecase (present i s))->
            (Q (lookup i (change_attrib i a s)) a);
Intros ___isp;
Refine Q_trans;
Refine (lookup i (add i a s));
Refine Q_resp;
Refine Q_sym;
Refine iftrue;
Refine isp;
Refine lkupadd1;
(*** QED ***)
Save chlkup1;


Goal {i,i':ident}{a':attrib}{s:symtab}
		  Q (present i (change_attrib i' a' s))
                    (present i s);

Intros ____;
Refine ifind ??? [x:symtab]Q (present i x)(present i s);
(* First case: (isthecase (present i' s)) *)
Intros isp;
Refine Q_trans;
Refine orelse (eqid i i')(present i s);
Refine presadd;
(* Case distinction *)
Refine bycases (eqid i i');
(* subcase: i=i'*)
Intros iqi';
Claim Q i' i;
(*Using the claim *)
Refine ?25 [j:ident]Q (orelse (eqid i i') (present j s)) (present j s);
Refine isp [b:bool]Q (orelse (eqid i i') b) b;
(* Proving that (orelse * true)=true *)
Refine Q_trans;
Refine orelse true (eqid i i');
Refine comm_or;
Refine Q_refl;
(*Proving the claim *)
Refine Q_sym;
Refine fst (Ident.2.2 ??);
Refine iqi';
(* subcase i # i'*)
Intros inqi';
Refine inqi' [x:bool]Q (orelse x (present i s)) (present i s);
(* Here all is normalized by the system *)
Refine Q_refl;
(* Second case (isnotthecase (present i' s)) *)
Intros isnp;Refine Q_refl;
(*** QED ***)
Save chpres;


Goal {i,i':ident}{a':attrib}{s:symtab}(isnotthecase (eqid i i'))->Q (lookup i (change_attrib i' a' s)) (lookup i s);
Intros ____inqi';
Refine ifind ??? [x:symtab]Q (lookup i x)(lookup i s);
(*First case: (isthecase (present i' s)) *)
Intros isp;
Refine lkupadd2;
Refine inqi';
(*Second case:(isnotthecase (present i' s)) *)
Intros isnp;Refine Q_refl;
(*** QED ***)
Save chlkup2;
impasse;
[ChangeAttrib_pre=(
symtab,
empty,add,change_attrib,present,
presempty,presadd,chpres,
lookup,
lkupempty,lkupadd1,lkupadd2,chlkup1,chlkup2):SYMTAB Ident Attrib];

Discharge Ident;
[ChangeAttrib:{Ident:IDENT}{Attrib:ATTRIB}CHANGE_ATTRIB Ident Attrib=ChangeAttrib_pre];
