cut;
mlbasics_;
SYMTAB_;
STCHATTR_;
SEQPAIRS_;
SEQDUP_;
step7sargs_;
memandism_;
uniqueids_;
nilandlength_;
lkuplems_;
axlookup_==Prop;

(************************************************************************)
Goal {i:ident}Q (lookup i empty) null_attrib;
(************************************************************************)

Intros i;
Refine Q_sym;
Refine Q_trans;
Next 11;
Refine unext ?? (recurse_law ???????);
Refine lkup_bc;Refine lkup_cc;
Refine Q_trans;Next 31;
Refine unext ?? (iftrue ?????);
Refine Snull1;
Refine Q_refl;
Save lkupempty;


(** A useful lemma *******************************************************)
Goal {i:ident}{a:attrib}{s:Ssequence}ex[s1:Ssequence]
Q (Scons (pair i a) s1)(Sadd (pair i a) s);

(*************************************************************************)

Intros i a s;
Refine bycases (Sismatch i s);
Intros ism;
Refine (Q_sym (Sadd1 ????)[x:Ssequence]ex ([s1:Ssequence]Q (Scons (pair i a) s1) x));
Refine ism;
Refine ex_intro;
Refine Sremove i s;Refine Q_refl;
Intros isnm;
Refine Q_sym (Sadd2 ????)[x:Ssequence]
ex ([s1:Ssequence]Q (Scons (pair i a) s1) x);
Refine isnm;
Refine ex_intro;
Refine s;Refine Q_refl;
Save Sadd_is_a_cons;


(***************************************************************************)
Goal {i:ident}{a:attrib}{s:symtab}
      		  Q (lookup i (add i a s)) a;
(***************************************************************************)

Intros i a s'';
s==s''.1;
Refine Q_sym;
Refine Sadd_is_a_cons i a s;
Intros s1 H;
Refine H[x:Ssequence]Q a (lookup_tw x i);
Refine Q_trans;
Next 16;Refine unext ?? (recurse_law ???????);
Refine lkup_bc;Refine lkup_cc;
Refine Q_trans;
Next 36;
Refine unext ?? (iffalse ?????);
Refine Snull2;
Refine Q_trans;
Next 54;
Refine iftrue;
Refine Q_sym (Shdax ??)[e:PROD ident attrib]
isthecase (eqid i (pi1 e));
Refine eq_refl;Refine Ident.2.2;
Refine Q_sym (Shdax ??)[e:PROD ident attrib]
Q a (pi2 e);
Refine Q_refl;
Save lkupadd1;

(**************************************************************************)
Goal {i,i':ident}{a':attrib}{s'':symtab}
		  (isnotthecase (eqid i i')) ->
		  (Q (lookup i (add i' a' s'')) (lookup i s''));
(***************************************************************************)

Intros ____ inqi';
[s=s''.1];
[ind:gen_by_add s=s''.2];

Refine bycases (Sismatch i' s);

(*** 1st case: Complicated because Sremove is involved ***)
Intros ism;
Refine Q_sym (Sadd1 ????)[x:Ssequence]
Q(lookup_tw x i)(lookup_tw s i);
Refine ism;
Refine Q_sym;Refine Q_trans;
Next 24;
Refine unext ?? (recurse_law ???????);
Refine lkup_bc;Refine lkup_cc;
Refine Q_trans;
Next 44;
Refine unext ?? (iffalse ?????);
Refine Snull2;
Refine Q_trans;
Next 62;
Refine iffalse;
Refine Q_sym(Shdax ??)[e:PROD ident attrib]isnotthecase (eqid i (pi1 e));
Refine inqi';
Equiv Q (lookup_tw s i) (lookup_tw  (Stl (Scons (pair i' a') (Sremove i' s))) i);
Refine Q_sym (Stlax ??)[x:Ssequence]
Q (lookup_tw s i)(lookup_tw x i);


Refine memtolkup;Intros member;
Refine uselocal;Intros eqe;
Refine uselocal;Intros eqt;
Refine uselocal;Intros memnil;
Refine uselocal;Intros memcons;
Intros memremanduniqandmemtolookup;
memrem==fst memremanduniqandmemtolookup;
uniq==fst(snd memremanduniqandmemtolookup);
memtolookup==snd(snd memremanduniqandmemtolookup);

Refine Q_sym;
Refine bycases (Sismatch i s);
Intros ismi; (** ismatch case by memtolookup**)
Equiv Q (lookup_tw (Sremove i' s) i) (lookup i s'');
Refine memtolookup;
i'nqi==eq_sym' eqid Ident.2.2 i i' isnotthecase inqi';
Refine memrem????i'nqi isthecase; 
Refine lkuptomem;
Immed;
Refine ismtomem; (**We have to proceed this way because of the f
                    Existential Quantification in ismtomem**)
Refine i;Refine s;Immed;
Intros a ismem;
Refine memtoism;Immed;
Refine ExIntro;Refine a;
Refine Q_sym(memrem????i'nqi)isthecase;
Immed;
Intros notism;
Refine Q_trans;Refine null_attrib;
Refine Q_sym;
Refine notismtonullattrib;
Refine notismtonotismrem;Refine notism;
Refine notismtonullattrib;Immed;

(*** The second case is much easier ***)
Intros notism;
Refine Q_sym (Sadd2 ????)[x:Ssequence]
Q(lookup_tw x i)(lookup_tw s i);
Refine notism;
Refine Q_sym;Refine Q_trans;
Next +2;
Refine unext ?? (recurse_law ???????);
Refine lkup_bc;Refine lkup_cc;
Refine Q_trans;
Next +2;
Refine unext ?? (iffalse ?????);
Refine Snull2;
Refine Q_trans;
Next +2;
Refine iffalse;
Refine Q_sym(Shdax ??)[e:PROD ident attrib]isnotthecase (eqid i (pi1 e));
Refine inqi';
Refine Q_sym (Stlax ??)[x:Ssequence]
Q (lookup_tw s i)(lookup_tw x i);
Refine Q_refl;
Save lkupadd2;
