cut;
mlbasics_;
SYMTAB_;
STCHATTR_;
SEQPAIRS_;
SEQDUP_;
step7sargs_;
memandism_;
[nilandlength_=Prop];
(** Some lemmas relating Snull, Slength and Sremove are proved *)

Goal {s:Ssequence}or (Q Snil s)(ex[s':Ssequence]ex[e:PROD ident attrib]Q (Scons e s')s);
Refine Sseqind[s:Ssequence]or (Q Snil s) (ex ([s':Ssequence]ex ([e:PROD ident attrib]Q (Scons e s') s)));
Refine inl;Refine Q_refl;
Intros ___;
Refine inr;
Refine ex_intro;
Refine s;Refine ex_intro;Refine e;
Refine Q_refl;
Save imScons;

(** Another form of imScons that is more adapted to our needs *)
Goal {P:Ssequence->Prop}{s|Ssequence}
((Q Snil s)->P Snil)->
({s':Ssequence}{e1:ident}{e2:attrib}
 (Q (Scons (pair e1 e2) s') s)->P (Scons (pair e1 e2) s'))->
P s;
Intros P s Hnil Hcons;
Refine imScons s;
Intros qsnil;
Refine qsnil P;
Refine Hnil qsnil;
Intros H;Refine H;Intros s' H1;Refine H1;Intros e;
Refine Q_sym (prod_eta_elem e)[e:PROD ident attrib]
(Q (Scons e s') s)->P s;
Intros qscons;
Refine qscons P;
Refine Hcons ??? qscons;
Save expandseq;


Goal {s:Ssequence}(Q zero (Slength  s))->Q Snil s;
Intros s;
Intros isn;
Refine imScons s;
Intros H;Refine H;
Intros H;Refine H;
Intros s1;
Intros H1;Refine H1;
Intros e1;
Intros isaconss;
Refine not_is_succ_zero;
Refine ex_intro;
Refine Slength s1;
Refine Q_trans;
Refine Slength s;
Immed;
Refine isaconss[x:Ssequence]Q (Slength x) (succ (Slength s1));
Refine Q_sym;
Refine Sconsrec;
Refine Q_refl;
Save SlengthtoQSnil;


Goal {i:ident}Q Snil (Sremove i Snil);
Intros i;
Refine expandseq[s:Ssequence]Q Snil s;
Intros _;Refine Q_refl; (** The nil case by Q_refl **)
Refine  Sremove2;Intros member;
Refine uselocal;Intros eqe;
Refine uselocal;Intros eqt;
Refine uselocal;Intros memnil;
Refine uselocal;Intros memcons;
Intros memrem;
Intros ___;
Intros H;Refine contradiction (member (pair e1 e2) (Sremove i Snil));  (** The cons case by contradiction **)
Refine H[x:Ssequence]isthecase (member (pair e1 e2) x);

Refine Q_sym (memcons ???)[x:bool]isthecase x;
Refine eq_refl ???[x:bool]isthecase (orelse x (member (pair e1 e2) s'));
Immed;
Refine Q_refl;(** -> (e1,e2)\in (Sremove i Snil **)
Refine bycases (eqid i e1);(** in either case e \not\in ~ **)
Intros iqe1;(** 1st case by Sremove1 **)
IQE1==fst (Ident.2.2 i e1)iqe1;
Refine IQE1[x:ident]isnotthecase (member (pair x e2) (Sremove i Snil));
Refine notismtonotmem;Immed;
Refine Sremove1;
Intros inqe1;
Refine Q_sym (memrem ????inqe1)[x:bool]isnotthecase x;
Refine memnil;  (** 2nd case by memnil **)
Save SnilSrem;



Goal {s:Ssequence}(isthecase (Snull s))->Q Snil s;
Intros s;
Intros isn;
Refine imScons s;
Intros H;Refine H;
Intros H;Refine H;
Intros s1;
Intros H1;Refine H1;
Intros e1;
Intros isaconss;
Refine consistency;
Refine Q_trans;
Refine Snull s;
Immed;
Refine Q_sym;
Refine isaconss[x:Ssequence]Q false (Snull x);
Refine Snull2;
Save SnulltoQSnil;


