cut;
mlbasics_;
SYMTAB_;
STCHATTR_;
SEQPAIRS_;
SEQDUP_;
[step7sargs_=Prop];


(*** Implementation of Symtab'''  ***)

(*** We assume the arguments and unpack them ***)

[Ident:IDENT][Attrib:ATTRIB][ident=Ident.1]
[eqid:ident->ident->bool=Ident.2.1][attrib=Attrib.1]
[null_attrib=Attrib.2.2.1]
[Sp:SEQPAIRS Ident Attrib]
[Ssequence=Sp.1]
[Snil:Ssequence=Sp.2.1]
[Scons:(PROD ident attrib)->Ssequence->Ssequence=Sp.2.2.1]
[Sseqrec:
       {R|Prop}R->((PROD ident attrib)->Ssequence->R->R)->
          Ssequence->R=Sp.2.2.2.1]
[Sseqind:
    {P:Ssequence->Prop}(P Snil)->
                   ({e:PROD ident attrib}{s:Ssequence}
                          (P s)->P (Scons e s))->
		   {s:Ssequence}P s=Sp.2.2.2.2.1]
[Snilrec:{R|Prop}{g:R}{h:(PROD ident attrib)->Ssequence->R->R}
	Q g (Sseqrec g h Snil)=Sp.2.2.2.2.2.1]
[Sconsrec:{R|Prop}{g:R}{h:(PROD ident attrib)->Ssequence->R->R}
      {e:PROD ident attrib}{s:Ssequence}	
      Q (h e s (Sseqrec g h s))(Sseqrec g h (Scons e s))
         =Sp.2.2.2.2.2.2.1]
[Snull:Ssequence->bool=Sp.2.2.2.2.2.2.2.1]
[Snull1:isthecase (Snull Snil)=Sp.2.2.2.2.2.2.2.2.1]
[Snull2:{e:PROD ident attrib}{s:Ssequence}
    isnotthecase (Snull (Scons e s))=Sp.2.2.2.2.2.2.2.2.2.1]
[Shd:Ssequence->PROD ident attrib=Sp.2.2.2.2.2.2.2.2.2.2.1]
[Shdax:{e:PROD ident attrib}{s:Ssequence}Q (Shd (Scons e s)) e
  =Sp.2.2.2.2.2.2.2.2.2.2.2.1]
[Stl:Ssequence->Ssequence=Sp.2.2.2.2.2.2.2.2.2.2.2.2.1]
[Stlax:{e:PROD ident attrib}{s:Ssequence}Q (Stl (Scons e s)) s
   =Sp.2.2.2.2.2.2.2.2.2.2.2.2.2]
;
[S:SEQDUP Ident Attrib Sp]
[Sadd:(PROD ident attrib)->Ssequence->Ssequence=S.1]
[Sismatch:ident->Ssequence->bool=S.2.1]
[Sremove:ident->Ssequence->Ssequence=S.2.2.1]
[Sadd1:{i:ident}{a:attrib}{s:Ssequence} (isthecase (Sismatch i s)) ->
                     Q (Sadd (pair i a) s)
                       (Scons (pair i a) (Sremove i s))
	=S.2.2.2.1]
[Sadd2:{i:ident}{a:attrib}{s:Ssequence}(isnotthecase (Sismatch i s)) ->
                     Q (Sadd (pair i a) s)
                       (Scons (pair i a) s)
	=S.2.2.2.2.1]
[Sismatch1:{i:ident}isnotthecase (Sismatch i Snil)
	=S.2.2.2.2.2.1]
[Sismatch2:{i:ident}{i':ident}{a':attrib}{s:Ssequence}
    Q (Sismatch i (Scons (pair i' a') s)) 
      (orelse (eqid i i') (Sismatch i s))
	=S.2.2.2.2.2.2.1]
[Sremove1:{i:ident}{s:Ssequence}isnotthecase (Sismatch i (Sremove i s))
	=S.2.2.2.2.2.2.2.1]
[Sremove2:
(* local *)
        Ex [member:(PROD ident attrib)->Ssequence->bool]
 	Ex [eqe:(PROD ident attrib)->(PROD ident attrib)->bool]
	Ex [eqt:eqtype (PROD ident attrib) eqe]
 
   	 (* axioms for member *)
	Ex [memnil:{e:PROD ident attrib}isnotthecase (member e Snil)]
	Ex [memcons:{e,e':PROD ident attrib}{s:Ssequence}
           Q (member e (Scons e' s)) (orelse (eqe e e')(member e s))]
(* in *) 
       {i,i':ident}{a':attrib}{s:Ssequence}(isnotthecase (eqid i i'))->
     	  Q (member (pair i' a') (Sremove i s))
     	    (member (pair i' a') s)

=S.2.2.2.2.2.2.2.2];


(*** We implement Symtab' ***)

[gen_by_add[s:Ssequence]=
{P:Ssequence->Prop}(P Snil)->
                   ({s:Ssequence}{e:PROD ident attrib}(P s)->P(Sadd e s))->
                   P s];
[symtab=<s:Ssequence>gen_by_add s];
[add[i:ident][a:attrib][s:symtab]:symtab =
(Sadd (pair i a) s.1, 
[P:Ssequence->Prop][Pnil:P Snil][Pstab:{s:Ssequence}{e:PROD ident attrib}(P s)->P(Sadd e s)]Pstab s.1 (pair i a) (s.2 P Pnil Pstab) ):symtab];

[empty:symtab=(Snil,[P:Ssequence->Prop][Pnil:P Snil][_:{s:Ssequence}{e:PROD ident attrib}(P s)->P(Sadd e s)]Pnil):symtab];

[present:ident->symtab->bool=[i:ident][s:symtab]Sismatch i s.1];


(**  lookup by recursion **)
[Slength:Ssequence->nat=
Sseqrec zero ([_:PROD ident attrib][_:Ssequence][n:nat]succ n)];

[lkup_base = [_:Ssequence][_:ident]null_attrib];
[lkup_scheme[s:Ssequence][lk:Ssequence->ident->attrib][i:ident]
=
let (Shd s) ([e:PROD ident attrib][i'=pi1 e][a'=pi2 e]
               if (eqid i i') a' 
                              (lk (Stl s) i))];
      
[lookup_tw:Ssequence->ident->attrib
=
recurse Snull lkup_base lkup_scheme Slength];

[lookup:ident->symtab->attrib
=
[i:ident][s:symtab]lookup_tw s.1 i];       
  

(** The base condition **)
Goal base_condition Snull Slength;
Refine Sseqind[a:Ssequence](Q (Slength a) zero)->isthecase (Snull a);
(** Base case **)
Intros _;Refine Snull1;
Intros  e s _  qlcsz;
(** Inductive case by contradiction **)
Refine not_is_succ_zero;
Refine ex_intro;
Refine Slength s;
Refine Q_trans;
Refine Slength(Scons e s);
Refine Q_sym;Refine qlcsz;
Refine Q_sym;Refine Sconsrec;Refine Q_refl;
Save lkup_bc;
  

(** The continuity condition **)
Goal cont_condition Snull lkup_scheme Slength;
Expand cont_condition;
Refine Sseqind[a:Ssequence]  (** By cases nil or cons **)
or (isthecase (Snull a)) ({f1,f2:Ssequence->ident->attrib}({a':Ssequence}(LT (Slength a') (Slength a))->Q (f1 a') (f2 a'))->Q (lkup_scheme a f1) (lkup_scheme a f2));
Refine inl;Refine Snull1;
Intros e s _;
Refine inr;Intros f1 f2 f1qf2;
Claim Q (f1 (Stl (Scons e s)))(f2 (Stl (Scons e s)));
Expand lkup_scheme;
Refine ?14[x:ident->attrib]  (** Plugging in the claim **)
Q ([i:ident]let (Shd (Scons e s)) ([e'2:PROD ident attrib]if (eqid i (pi1 e'2)) (pi2 e'2) (f1 (Stl (Scons e s)) i))) ([i:ident]let (Shd (Scons e s)) ([e'2:PROD ident attrib]if (eqid i (pi1 e'2)) (pi2 e'2) (x i)));
Refine Q_refl;  
(** Proving the claim **)
Refine f1qf2;
(** Remains to prove that |tl s| < |tl (cons e s)|  **)
Refine Q_sym (Stlax ??)[x:Ssequence]
LT (Slength x)(Slength (Scons e s)); (** defn of tl **)
Refine (Sconsrec ????)[n:nat]LT (Slength s) n;
Refine LE_refl;
Save lkup_cc;

(** End of lookup **)
